#!/bin/bash
## THE PURPOSE OF THIS SCRIPT IS TO FIND UNUSED OBJECTS IN rulebases_5_0.fws FILE. IT FIRST GENERATES COPIES
## OF objects_5_0.C AND rulebases_5_0.fws FILES, AND JUST WORKS ON THESE COPIES. DOES NOT MODIFY THESE FILES 
## OR KEEPS THEM BUSY. THEN IT GENERATES THE UID LISTS AND THE GROUP OBJECT CONTENTS FROM objects_5_0.C.
## AFTERWARDS SEARCHES THE UIDS FIRST IN THE RULEBASE THEN IN THE GROUP OBJECT CONTENTS. 
#########################################

## MAKE A TEMP FILE OF objects_5_0.C TO WORK ON
cp objects_5_0.C actual_short_objects.temp

## FIRST EXTRACT UNNECESSARY WORDS TO CLEAN THE FILE
grep -v -f extracted_lines_list.txt actual_short_objects.temp > actual_short_objects.temp2

############ TO GET GROUP OBJECTS LIST:
## FIRST REMOVE IF THERE IS ANY
ls group_objects_list.txt >/dev/null 2>&1 && rm group_objects_list.txt >/dev/null 2>&1

## REMOVE PARENTHESES 
sed 's/(network_object_group)/network_object_group/' actual_short_objects.temp2 | \
sed 's/(group)/group/' > actual_short_objects.temp3

## GET THE CONTENT OF GROUP FOR EACH GROUP UID
## FIND LINE NO OF ":ClassName network_object_group", SUBTRACTING 2 GIVES THE STARTING LINE NO OF GROUPS
## AFTERWARDS GET CONTENT FROM STARTING LINE NO TO THE FIRST MATCH OF ":type group"

echo "Getting the contents of group objects."
for each in `awk '{lines[NR] = $0}/:ClassName network_object_group/{print NR}' actual_short_objects.temp3`
 do 
	line_start=`expr $each - 2`
	echo "Line number: $line_start"
sed -n  "$line_start,/:type group/p" actual_short_objects.temp3 >> group_objects_list.txt
done
echo "Finished getting the contents of group objects."

############ GET ALL UIDS FOR HOSTS & RANGES & NETWORKS & GROUPS & LDAP-USERS
## FIRST REMOVE IF THERE IS ANY
ls objects_names_uids_list.txt >/dev/null 2>&1 && rm objects_names_uids_list.txt >/dev/null 2>&1

echo "Getting the necessary uids."

grep -B2 ":ClassName (host_plain)" actual_short_objects.temp3 > objects_names_uids_list.txt
grep -B3 ":ClassName (address_range)" actual_short_objects.temp3 >> objects_names_uids_list.txt
grep -B2 ":ClassName (network)" actual_short_objects.temp3 >> objects_names_uids_list.txt
grep -B2 ":ClassName network_object_group" actual_short_objects.temp3 >> objects_names_uids_list.txt
grep -B2 ":ClassName (rule_user_group)" actual_short_objects.temp3 >> objects_names_uids_list.txt

## GET ONLY UIDS & REMOVE PUNCTUATION & SPACES
cat objects_names_uids_list.txt | grep chkpf_uid | sed s/:chkpf_uid// | sed s/\(\"{// | sed s/}\"\)// \
 | awk '{ sub(/^[ \t]+/, ""); print }' > objects_uids_list.txt

echo "Generated the uid lists."

############ SEARCH FOR UNUSED UIDS IN THE RULEBASE
## MAKE A TEMP FILE OF rulebases_5_0.fws TO WORK ON
cp rulebases_5_0.fws rulebases_5_0.fws.temp

echo "Searching for unused uids in the rulebase, this may take a while."

## FIRST REMOVE IF THERE IS ANY
ls unused_list1.txt >/dev/null 2>&1 && rm unused_list1.txt >/dev/null 2>&1

for object in `less objects_uids_list.txt`
   do
	grep -q -m 1 $object rulebases_5_0.fws.temp || echo $object >> unused_list1.txt
   done

echo "Finished searching unused uids in the rulebase."

############ SEARCH FOR UNUSED UIDS IN GROUPS

echo "Searching for unused uids in groups."

## FIRST REMOVE IF THERE IS ANY
ls unused_list2.txt >/dev/null 2>&1 && rm unused_list2.txt >/dev/null 2>&1

for object in `less unused_list1.txt`
   do
	grep -q -m 1 $object group_objects_list.txt || echo $object >> unused_list2.txt
   done

echo "Finished searching unused objects, generating the final list."

############ GETTING THE NAMES OF FINAL UNUSED OBJECTS
## FIRST REMOVE IF THERE IS ANY
ls unused_list_final.txt >/dev/null 2>&1 && rm unused_list_final.txt >/dev/null 2>&1

for unused_object in `less unused_list2.txt`
   do
	grep -B 1 $unused_object objects_names_uids_list.txt >> unused_list_final.txt
   done

## CLEANUP TEMP FILES
rm actual_short_objects.temp
rm actual_short_objects.temp2 
rm actual_short_objects.temp3
rm rulebases_5_0.fws.temp
rm group_objects_list.txt
rm objects_names_uids_list.txt
rm objects_uids_list.txt
rm unused_list1.txt
rm unused_list2.txt
